<?php

/** 
*
* mod package	Download Mod 5
* file		dl_admin_banlist.php v 1.1 2006/12/28 OXPUS
* copyright	(c) 2006 oxpus (Karsten Ude) <webmaster@oxpus.de> http://www.oxpus.de
* copyright mod	(c) hotschi / demolition fabi / oxpus
* license	http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/*
* connect to phpBB
*/
if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
}

if ($cancel)
{
	$action = '';
}

$action = (isset($HTTP_POST_VARS['edit_banlist'])) ? 'edit' : $action;
$action = (isset($HTTP_POST_VARS['delete_banlist'])) ? 'delete' : $action;

if($action == 'add')
{
	$ban_id = (isset($HTTP_POST_VARS['ban_id'])) ? intval($HTTP_POST_VARS['ban_id']) : 0;
	$user_id = (isset($HTTP_POST_VARS['user_id'])) ? intval($HTTP_POST_VARS['user_id']) : 0;
	$user_ip = (!empty($HTTP_POST_VARS['user_ip'])) ? encode_ip($HTTP_POST_VARS['user_ip']) : "";
	$user_agent = (isset($HTTP_POST_VARS['user_agent'])) ? htmlspecialchars($HTTP_POST_VARS['user_agent']) : "";
	$username = (isset($HTTP_POST_VARS['username'])) ? phpbb_clean_username($HTTP_POST_VARS['username']) : "";
	$guests = (isset($HTTP_POST_VARS['guests'])) ? intval($HTTP_POST_VARS['guests']) : 0;

	if ($ban_id)
	{
		$sql = "UPDATE " . DL_BANLIST_TABLE . "
			SET user_id = " . (int)$user_id . ", user_ip = '$user_ip', user_agent = '" . str_replace("\'", "''", $user_agent) . "', username = '" . str_replace("\'", "''", $username) . "', guests = " . (int)$guests . "
			WHERE ban_id = " . (int)$ban_id;
	}
	else
	{
		$sql = "INSERT INTO " . DL_BANLIST_TABLE . "
			(user_id, user_ip, user_agent, username, guests)
			VALUES
			(" . (int)$user_id . ", '$user_ip', '" . str_replace("\'", "''", $user_agent) . "', '" . str_replace("\'", "''", $username) . "', " . (int)$guests . ")";
	}

	if (!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not save ban values', '', __LINE__, __FILE__, $sql);
	}

	$action = '';
}
else if($action == 'delete')
{
	$ban_id = (isset($HTTP_POST_VARS['ban_id'])) ? $HTTP_POST_VARS['ban_id'] : array();

	if (!$confirm)
	{
		$template->set_filenames(array(
			'confirm_body' => 'dl_mod/tpl/dl_confirm_body.tpl')
		);

		for ($i = 0; $i < sizeof($ban_id); $i++)
		{
			$s_hidden_fields .= '<input type="hidden" name="ban_id[]" value="'.intval($ban_id[$i]).'" />';
		}

		$s_hidden_fields .= '<input type="hidden" name="action" value="delete" />';

		$template->assign_vars(array(
			'MESSAGE_TITLE' => $lang['Information'],
			'MESSAGE_TEXT' => $lang['Dl_confirm_delete_ban_values'],

			'L_YES' => $lang['Yes'],
			'L_NO' => $lang['No'],

			'S_CONFIRM_ACTION' => append_sid("admin_downloads.$phpEx?submod=banlist"),
			'S_HIDDEN_FIELDS' => $s_hidden_fields)
		);

		$template->pparse('confirm_body');

		include('./page_footer_admin.'.$phpEx);
	}
	else
	{
		$sql_ext_in = '';
		for ($i = 0; $i < sizeof($ban_id); $i++)
		{
			$sql_ext_in .= ($sql_ext_in != '') ? ", ".intval($ban_id[$i]) : intval($ban_id[$i]);
		}

		if ($sql_ext_in)
		{
			$sql = "DELETE FROM " . DL_BANLIST_TABLE . "
				WHERE ban_id IN ($sql_ext_in)";

			if( !($db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, "Couldn't delete banlist value(s)", "", __LINE__, __FILE__, $sql);
			}

			message_die(GENERAL_MESSAGE, $lang['Dl_banlist_updated'] . "<br /><br />" . sprintf($lang['Click_return_banlistadmin'], "<a href=\"" . append_sid("admin_downloads.$phpEx?submod=banlist") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>"));
		}

		$action = '';
	}
}

if ($action == '' || $action == 'edit')
{
	$template->set_filenames(array(
		'banlist' => 'dl_mod/tpl/admin/dl_banlist_body.tpl')
	);

	$sql = "SELECT * FROM " . DL_BANLIST_TABLE . "
		ORDER BY ban_id";
	if(!($result = $db->sql_query($sql)))
	{
		message_die(GENERAL_ERROR, 'Could not query banlist', '', __LINE__, __FILE__, $sql);
	}

	$i = 0;

	while ($row = $db->sql_fetchrow($result))
	{
		$row_class = (($i % 2)) ? $theme['td_class1'] : $theme['td_class2'];

		$ban_id = $row['ban_id'];
		$user_id = $row['user_id'];
		$user_ip = ($row['user_ip']) ? decode_ip($row['user_ip']) : '';
		$user_agent = $row['user_agent'];
		$username = $row['username'];
		$guests = $row['guests'];

		$template->assign_block_vars('banlist_row', array(
			'ROW_CLASS' => $row_class,
			'BAN_ID' => $ban_id,
			'USER_ID' => $user_id,
			'USER_IP' => $user_ip,
			'USER_AGENT' => $user_agent,
			'USERNAME' => $username,
			'GUESTS' => ($guests) ? $lang['Yes'] : $lang['No'])
		);

		$i++;
	}
	$db->sql_freeresult($result);

	$ban_id = (isset($HTTP_POST_VARS['ban_id'])) ? $HTTP_POST_VARS['ban_id'] : array();
	$banlist_id = intval($ban_id[0]);

	$s_hidden_fields = '<input type="hidden" name="action" value="add" />';

	if ($action == 'edit' && $banlist_id)
	{

		$sql = "SELECT * FROM " . DL_BANLIST_TABLE . "
			WHERE ban_id = $banlist_id";
		if(!($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Could not query banlist', '', __LINE__, __FILE__, $sql);
		}

		while ($row = $db->sql_fetchrow($result))
		{
			$ban_id = $row['ban_id'];
			$user_id = $row['user_id'];
			$user_ip = ($row['user_ip']) ? decode_ip($row['user_ip']) : '';
			$user_agent = $row['user_agent'];
			$username = $row['username'];
			$guests = $row['guests'];
			$s_hidden_fields .= '<input type="hidden" name="ban_id" value="'.$ban_id.'" />';
		}
		$db->sql_freeresult($result);
	}
	else
	{
		$ban_id = '';
		$user_id = '';
		$user_ip = '';
		$user_agent = '';
		$username = '';
		$guests = '';
	}

	$template->assign_vars(array(
		'L_DL_BANLIST_EXPLAIN' => $lang['Dl_acp_banlist_explain'],
		'L_DL_USER_ID' => $lang['Dl_user_id'],
		'L_DL_USER_IP' => $lang['Dl_ip'],
		'L_DL_USER_AGENT' => $lang['Dl_browser'],
		'L_DL_USERNAME' => $lang['Username'],
		'L_DL_GUESTS' => $lang['Guest'],
		'L_DL_ADD_NEW' => $lang['Submit'],
		'L_DL_DELETE' => $lang['Dl_delete'],
		'L_DL_YES' => $lang['Yes'],
		'L_DL_NO' => $lang['No'],
		'L_MARK_ALL' => $lang['Mark_all'],
		'L_UNMARK_ALL' => $lang['Unmark_all'],
		'L_DL_EDIT' => $lang['Edit'],

		'DL_USER_ID' => $user_id,
		'DL_USER_IP' => $user_ip,
		'DL_USER_AGENT' => $user_agent,
		'DL_USERNAME' => $username,
		'CHECKED_YES' => ($guests) ? 'checked="checked"' : '',
		'CHECKED_NO' => (!$guests) ? 'checked="checked"' : '',

		'S_HIDDEN_FIELDS' => $s_hidden_fields,
		'S_DOWNLOADS_ACTION' => append_sid("admin_downloads.$phpEx?submod=banlist"))
	);
}

$template->pparse('banlist');

?>