<?php

/** 
*
* mod package	Download Mod 5
* file		hacks_list.php v 1.2 2006/08/19 OXPUS
* copyright	(c) 2005 oxpus (Karsten Ude) <webmaster@oxpus.de> http://www.oxpus.de
* copyright mod	(c) hotschi / demolition fabi / oxpus
* license	http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/*
* connect to phpBB
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);

/*
* session management
*/
$userdata = session_pagestart($user_ip, PAGE_HACKSLIST);
init_userprefs($userdata);

/*
* init and get various values
*/
$params = array('sort_by' => 'sort_by', 'order' => 'order');
while( list($var, $param) = @each($params) )
{
	if ( !empty($HTTP_POST_VARS[$param]) || !empty($HTTP_GET_VARS[$param]) )
	{
		$$var = ( !empty($HTTP_POST_VARS[$param]) ) ? htmlspecialchars($HTTP_POST_VARS[$param]) : htmlspecialchars($HTTP_GET_VARS[$param]);
	}
	else
	{
		$$var = '';
	}
}

$s_sort_by = '<select name="sort_by" onchange="if(this.options[this.selectedIndex].value != -1){ forms[\'hacklist\'].submit() }">';
$s_sort_by .= '<option value="0">'.$lang['Dl_default_sort'].'</option>';
$s_sort_by .= '<option value="1">'.$lang['Dl_file_description'].'</option>';
$s_sort_by .= '<option value="2">'.$lang['Dl_hack_autor'].'</option>';
$s_sort_by .= '</select>';
$s_sort_by = str_replace('value="'.$sort_by.'">', 'value="'.$sort_by.'" selected="selected">', $s_sort_by);

$s_order = '<select name="order" onchange="if(this.options[this.selectedIndex].value != -1){ forms[\'hacklist\'].submit() }">';
$s_order .= '<option value="ASC">'.$lang['Sort_Ascending'].'</option>';
$s_order .= '<option value="DESC">'.$lang['Sort_Descending'].'</option>';
$s_order .= '</select>';
$s_order = str_replace('value="'.$order.'">', 'value="'.$order.'" selected="selected">', $s_order);

$start = (isset($HTTP_GET_VARS['start'])) ? intval($HTTP_GET_VARS['start']) : 0;
$start = ($start < 0) ? 0 : $start;

switch ($sort_by)
{
	case 1:
		$sql_sort_by = 'long_desc';
		break;
	case 2:
		$sql_sort_by = 'hack_author';
		break;
	default:
		$sql_sort_by = 'description';
}

$sql_order = ($order) ? $order : 'ASC';

/*
* include and create the hacklist class
*/
include($phpbb_root_path . 'dl_mod/classes/class_hacklist.'.$phpEx);
$dl_mod = new hacklist();

$hacklist = array();
$hacklist = $dl_mod->hacks_index();
$status = $dl_mod->hacklist_status();

if (!$status || !sizeof($hacklist))
{
	$redirect_url = (@file_exists($phpbb_root_path.'portal.'.$phpEx)) ? "portal" : "index";
	redirect(append_sid("$redirect_url.$phpEx"));
}

$page_title = $lang['Dl_hacks_list'];
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->set_filenames(array(
	'body' => 'dl_mod/tpl/hacks_list_body.tpl')
);

$dl_files = array();
$dl_files = $dl_mod->all_files($sql_sort_by, $sql_order, 'LIMIT ' . $start . ', ' . $board_config['topics_per_page']);

$all_files = array();
$all_files = $dl_mod->all_files('id', 'ASC');

$pagination = (sizeof($all_files) > $board_config['topics_per_page']) ? generate_pagination("hacks_list.$phpEx?sort_by=$sort_by&amp;order=$order", sizeof($all_files), $board_config['topics_per_page'], $start) : '';

$template->assign_vars(array(
	'L_NAME' => $lang['Dl_name'],
	'L_DL_HACK_AUTHOR' => $lang['Dl_hack_autor'],
	'L_DL_HACK_AUTHOR_WEBSITE' => $lang['Dl_hack_autor_website'],
	'L_DL_DESCRIPTION' => $lang['Dl_file_description'],
	'L_DL_HACK_DL_URL' => $lang['Dl_hack_dl_url'],

	'L_SORT_BY' => $lang['Sort_by'],
	'L_ORDER' => $lang['Order'],
	'L_GO' => $lang['Go'],

	'PAGE_NAME' => $page_title,
	'PAGINATION' => $pagination,

	'S_SORT_BY' => $s_sort_by,
	'S_ORDER' => $s_order,

	'U_DOWNLOADS' => append_sid("hacks_list.$phpEx"))
);

if (sizeof($dl_files))
{
	for ($i = 0; $i < sizeof($dl_files); $i++)
	{
		$cat_id = $dl_files[$i]['cat'];
		if ($hacklist[$cat_id])
		{
			$hack_name = $dl_files[$i]['description'];
			$hack_author = ($dl_files[$i]['hack_author'] != '') ? $dl_files[$i]['hack_author'] : 'n/a';
			$hack_author_email = $dl_files[$i]['hack_author_email'];
			$hack_author_website = $dl_files[$i]['hack_author_website'];
			$hackname = ($dl_files[$i]['hacklist'] != '') ? '&nbsp;'.$dl_files[$i]['description'] : '';
			$hack_version = ($dl_files[$i]['hacklist'] != '') ? '&nbsp;'.$dl_files[$i]['hack_version'] : '';
			$hack_dl_url = $dl_files[$i]['hack_dl_url'];
			$description = stripslashes($dl_files[$i]['long_desc']);
			$bbcode_uid = $dl_files[$i]['bbcode_uid'];
			$description = ($bbcode_uid != '') ? bbencode_second_pass($description, $bbcode_uid) : $description;
			$description = make_clickable($description);
			$description = str_replace("\n", "\n<br />\n", $description);

			$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

			$template->assign_block_vars('listrow', array(
				'ROW_CLASS' => $row_class,
				'CAT_NAME' => $hacklist[$cat_id],
				'HACK_NAME' => $hackname . $hack_version,
				'HACK_DESCRIPTION' => $description,
				'HACK_AUTHOR' => ($hack_author_email != '') ? '<a href="mailto:' . $hack_author_email . '">'.$hack_author.'</a>' : $hack_author,
				'HACK_AUTHOR_WEBSITE' => ($hack_author_website != '') ? '<a href="'.$hack_author_website.'" target="_blank"><img src="'.$images['Dl_homepage'].'" border="0" alt="'.$lang['Dl_hack_autor_website'].'" title="'.$lang['Dl_hack_autor_website'].'"/></a>' : 'n/a',
				'HACK_DL_URL' => ($hack_dl_url != '') ? '<a href="'.$hack_dl_url.'" target="_blank"><img src="'.$images['Dl_download'].'" border="0" alt="'.$lang['Dl_download'].'" title="'.$lang['Dl_download'].'"/></a>' : 'n/a')
			);
		}
	}
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>