<?php
/** 
*
* mod package	Download Mod 5
* file		admin_dl_cash_to_traffic.php v 1.2 2006/08/28 OXPUS
* copyright	(c) 2005 oxpus (Karsten Ude) <webmaster@oxpus.de> http://www.oxpus.de
* copyright mod	(c) hotschi / demolition fabi / oxpus
* license	http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['General']['Dl_cash_to_traffic'] = $file;
	return;
}

define('IN_PHPBB', true);
define('IN_CASHMOD', true);

$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include_once($phpbb_root_path . 'includes/functions_cash.' . $phpEx);

if(isset($HTTP_POST_VARS['submit']))
{
	$sql = "SELECT * FROM " . CASH_TABLE;
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not fetch exiting cash currencies", "", __LINE__, __FILE__, $sql);
	}

	while( $row = $db->sql_fetchrow($result) )
	{
		$cash_id = $row['cash_id'];
		$cash_to_traffic_in = intval($HTTP_POST_VARS['cash_to_traffic_'.$cash_id]);
		$exrange = $HTTP_POST_VARS['cash_to_traffic_range_'.$cash_id];

		switch($exrange)
		{
			case 'kb':
				$cash_to_traffic = floor($cash_to_traffic_in * 1024);
				break;
			case 'mb':
				$cash_to_traffic = floor($cash_to_traffic_in * 1048576);
				break;
			default:
				$cash_to_traffic = $cash_to_traffic_in;
		}

		$sql_new = "UPDATE " . CASH_TABLE . " SET
				cash_to_traffic = $cash_to_traffic
				WHERE cash_id = " . $row['cash_id'];
		if( !$db->sql_query($sql_new) )
		{
			message_die(GENERAL_ERROR, "Failed to update exchange for cash currency", "", __LINE__, __FILE__, $sql_new);
		}
	}
	$db->sql_freeresult($result);
}

//
// Get the existing currencies from Cash Mod
//
$sql = "SELECT * FROM " . CASH_TABLE . "
	ORDER BY cash_name";
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not fetch exiting cash currencies", "", __LINE__, __FILE__, $sql);
}

$template->set_filenames(array(
	'body' => 'dl_mod/tpl/admin/dl_cash_to_traffic.tpl')
);

while( $row = $db->sql_fetchrow($result) )
{
	$cash_id = $row['cash_id'];
	$cash_name = $row['cash_name'];
	$cash_to_traffic = $row['cash_to_traffic'];

	if ($cash_to_traffic < 1024)
	{
		$cash_to_traffic_out = $cash_to_traffic;
		$cash_to_traffic_range2 = $cash_to_traffic_range3 = $cash_to_traffic_range4 = '';
		$cash_to_traffic_range1 = 'checked="checked"';
	}
	else if ($cash_to_traffic < 1048576)
	{
		$cash_to_traffic_out = floor($cash_to_traffic / 1024);
		$cash_to_traffic_range1 = $cash_to_traffic_range3 = $cash_to_traffic_range4 = '';
		$cash_to_traffic_range2 = 'checked="checked"';
	}
	else
	{
		$cash_to_traffic_out = floor($cash_to_traffic / 1048576);
		$cash_to_traffic_range1 = $cash_to_traffic_range2 = $cash_to_traffic_range4 = '';
		$cash_to_traffic_range3 = 'checked="checked"';
	}

	$template->assign_block_vars('exchange_cash_row', array(
		'CASH_NAME' => $cash_name,
		'CASH_ID' => $cash_id,
		'CASH_TO_TRAFFIC' => $cash_to_traffic_out,
		'CASH_TO_TRAFFIC_RANGE1' => $cash_to_traffic_range1,
		'CASH_TO_TRAFFIC_RANGE2' => $cash_to_traffic_range2,
		'CASH_TO_TRAFFIC_RANGE3' => $cash_to_traffic_range3)
	);
}

$template->assign_vars(array(
	'L_CASH_TITLE' => $lang['Dl_cash_to_traffic'],
	'L_CASH_EXPLAIN' => $lang['Dl_cash_to_traffic_explain'],
	'L_DL_TRAFFIC' => $lang['Traffic'],
	'L_CASH_CURRENY' => $lang['Dl_cash_currency'],

	'L_SUBMIT' => $lang['Submit'],
	'L_RESET' => $lang['Reset'],

	'S_EXCHANGE_ACTION' => append_sid('admin_dl_cash_to_traffic.'.$phpEx))
);

$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>