<?php
/***************************************************************************
 *                               db_update.php
 *                            -------------------
 *
 *   copyright            : 2003 Freakin' Booty ;-P & Antony Bailey
 *   project              : http://sourceforge.net/projects/dbgenerator
 *   Website              : http://freakingbooty.no-ip.com/ & http://www.rapiddr3am.net
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

if( !$userdata['session_logged_in'] )
{
	$header_location = ( @preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE')) ) ? 'Refresh: 0; URL=' : 'Location: ';
	header($header_location . append_sid("login.$phpEx?redirect=db_update.$phpEx", true));
	exit;
}

if( $userdata['user_level'] != ADMIN )
{
	message_die(GENERAL_MESSAGE, 'You are not authorised to access this page');
}

$current_version = '5.1.3';

$page_title = 'Updating the database';
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

echo '<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">';
echo '<tr><th>Updating the database</th></tr><tr><td><span class="genmed"><ul type="circle">';

echo '<li><b>Check Downloads Table </b><u>'.$table_prefix.'downloads</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "downloads (
	id INT(11) auto_increment NOT NULL,
	description VARCHAR(255) DEFAULT '',
	file_name VARCHAR(255) DEFAULT '',
	klicks INT(11) DEFAULT '0',
	free TINYINT(1) DEFAULT '0',
	extern TINYINT(1) DEFAULT '0',
	long_desc TEXT DEFAULT '',
	sort INT(11) DEFAULT '0',
	cat INT(11) DEFAULT '0',
	hacklist TINYINT(1) DEFAULT '0',
	hack_author VARCHAR(255) DEFAULT '',
	hack_author_email VARCHAR(255) DEFAULT '',
	hack_author_website TINYTEXT DEFAULT '',
	hack_version VARCHAR(32) DEFAULT '',
	hack_dl_url TINYTEXT DEFAULT '',
	test varchar(50) DEFAULT '',
	req TEXT DEFAULT '',
	todo TEXT DEFAULT '',
	warning TEXT DEFAULT '',
	mod_desc TEXT DEFAULT '',
	bbcode_uid VARCHAR(10) DEFAULT '',
	mod_list TINYINT(1) DEFAULT '0',
	file_size BIGINT(20) NOT NULL DEFAULT '0',
	change_time INT(11) DEFAULT '0',
	add_time INT(11) DEFAULT '0',
	rating SMALLINT(5) DEFAULT '0' NOT NULL,
	file_traffic BIGINT(20) NOT NULL DEFAULT '0',
	overall_klicks INT(11) DEFAULT '0',
	approve TINYINT(1) DEFAULT '0',
	add_user MEDIUMINT(8) DEFAULT '0',
	change_user MEDIUMINT(8) DEFAULT '0',
	last_time INT(11) DEFAULT '0',
	down_user MEDIUMINT(8) DEFAULT '0' NOT NULL,
	thumbnail VARCHAR(255) DEFAULT '' NOT NULL,
	broken TINYINT(1) NOT NULL DEFAULT 0,
PRIMARY KEY  (id))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'downloads created</b></font></li><br />';
}

$current_time = time();

$sql = "UPDATE " . $table_prefix . "downloads SET change_time = $current_time, add_time = $current_time, add_user = " . $userdata['user_id'] . ", change_user = " . $userdata['user_id'];
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Time on '.$table_prefix.'downloads updated</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Categories Table </b><u>'.$table_prefix.'downloads_cat</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "downloads_cat (
	id INT(11) auto_increment NOT NULL,
	parent INT(11) DEFAULT '0',
	path VARCHAR(255) DEFAULT '',
	cat_name VARCHAR(255) DEFAULT '',
	sort INT(11) DEFAULT '0',
	description TEXT DEFAULT '',
	rules TEXT DEFAULT '',
	bbcode_uid VARCHAR(10) DEFAULT '',
	auth_view TINYINT(1) DEFAULT '1' NOT NULL,
	auth_dl TINYINT(1) DEFAULT '1' NOT NULL,
	auth_up TINYINT(1) DEFAULT '0' NOT NULL,
	auth_mod TINYINT(1) DEFAULT '0' NOT NULL,
	must_approve TINYINT(1) DEFAULT '0' NOT NULL,
	allow_mod_desc TINYINT(1) DEFAULT '0' NOT NULL,
	statistics TINYINT(1) DEFAULT '1' NOT NULL,
	stats_prune MEDIUMINT(8) DEFAULT '0' NOT NULL,
	comments TINYINT(1) DEFAULT '1' NOT NULL,
	cat_traffic BIGINT(20) DEFAULT '0' NOT NULL,
	cat_traffic_use BIGINT(20) DEFAULT '0' NOT NULL,
	allow_thumbs TINYINT(1) DEFAULT '0' NOT NULL,
	auth_cread TINYINT(1) NOT NULL DEFAULT '0',
	auth_cpost TINYINT(1) NOT NULL DEFAULT '1',
	approve_comments TINYINT(1) NOT NULL DEFAULT '1',
PRIMARY KEY  (id))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'downloads_cat created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Permissions Table </b><u>'.$table_prefix.'dl_auth</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_auth (
	cat_id INT(11) NOT NULL,
	group_id INT(11) NOT NULL,
	auth_view TINYINT(1) DEFAULT '1' NOT NULL,
	auth_dl TINYINT(1) DEFAULT '1' NOT NULL,
	auth_up TINYINT(1) DEFAULT '1' NOT NULL,
	auth_mod TINYINT(1) DEFAULT '0' NOT NULL)";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_auth created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Comments Table </b><u>'.$table_prefix.'dl_comments</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_comments (
	dl_id bigint(20) unsigned auto_increment NOT NULL,
	id int(11) NOT NULL default '0',
	cat_id int(11) NOT NULL default '0',
	user_id mediumint(8) NOT NULL default '0',
	username varchar(32) NOT NULL default '',
	comment_time int(11) NOT NULL default '0',
	comment_edit_time int(11) NOT NULL default '0',
	comment_text text NOT NULL default '', 
	bbcode_uid varchar(10) NOT NULL default '',
	approve tinyint(1) NOT NULL default '0',
	PRIMARY KEY (dl_id))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_comments created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Rating Table </b><u>'.$table_prefix.'dl_ratings</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_ratings (
	dl_id INT(11) DEFAULT '0',
	user_id MEDIUMINT(8) DEFAULT '0',
	rate_point VARCHAR(10) DEFAULT '0')";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_ratings created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Statistics Table </b><u>'.$table_prefix.'dl_stats</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_stats (
	dl_id bigint(20) unsigned auto_increment NOT NULL,
	id int(11) NOT NULL default '0',
	cat_id int(11) NOT NULL default '0',
	user_id mediumint(8) NOT NULL default '0',
	username varchar(32) NOT NULL default '',
	traffic bigint(20) NOT NULL default '0',
	direction tinyint(1) NOT NULL default '0',
	user_ip varchar(8) NOT NULL default '',
	browser varchar(20) NOT NULL default '',
	time_stamp int(11) NOT NULL default '0',
	PRIMARY KEY (dl_id))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_stats created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Configuration Table </b><u>'.$table_prefix.'dl_config</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_config (
	config_name VARCHAR(255) NOT NULL default '',
	config_value VARCHAR(255) NOT NULL default '',
PRIMARY KEY  (config_name))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_config created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check No Traffic Table </b><u>'.$table_prefix.'dl_notraf</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_notraf (
	user_id MEDIUMINT(8) NOT NULL DEFAULT 0,
	dl_id INT(11) NOT NULL DEFAULT 0
)";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_notraf created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Hotlink Table </b><u>'.$table_prefix.'dl_hotlink</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_hotlink (
	user_id MEDIUMINT(8) NOT NULL DEFAULT 0,
	session_id VARCHAR(32) NOT NULL DEFAULT '',
	hotlink_id VARCHAR(32) NOT NULL DEFAULT '',
	code VARCHAR(5) NOT NULL DEFAULT ''
	)";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_hotlink created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check File Extention Blacklist Table </b><u>'.$table_prefix.'dl_ext_blacklist</u></li><br />';

$sql = "CREATE TABLE ".$table_prefix."dl_ext_blacklist (
		extention VARCHAR(10) DEFAULT '' NOT NULL
	)";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_ext_blacklist created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Downloads Table </b><u>'.$table_prefix.'dl_banlist</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_banlist (
	ban_id INT(11) AUTO_INCREMENT NOT NULL,
	user_id MEDIUMINT(8) DEFAULT 0 NOT NULL,
	user_ip CHAR(8) DEFAULT '' NOT NULL,
	user_agent VARCHAR(50) DEFAULT '' NOT NULL,
	username VARCHAR(25) DEFAULT '' NOT NULL,
	guests TINYINT(1) DEFAULT 0 NOT NULL,
	PRIMARY KEY (ban_id))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_banlist created</b></font></li><br />';
}

$sql = "INSERT INTO " . $table_prefix . "dl_banlist (user_agent) VALUES ('n/a')";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Insert default ban value into '.$table_prefix.'dl_banlist</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Check Downloads Table </b><u>'.$table_prefix.'dl_favorites</u></li><br />';

$sql = "CREATE TABLE " . $table_prefix . "dl_favorites (
	fav_id INT(11) AUTO_INCREMENT NOT NULL,
	fav_dl_id INT(11) DEFAULT 0 NOT NULL,
	fav_dl_cat INT(11) DEFAULT 0 NOT NULL,
	fav_user_id MEDIUMINT(8) DEFAULT 0 NOT NULL,
PRIMARY KEY (fav_id))";
$db->sql_query($sql);
$error = $db->sql_error();
if ($error['message'] != '')
{
	echo '<li>' . $sql . '<br /> +++ <font color="#FF0000"><b>Failed: </b>'.$error['message'].'</font></li><br />';
}
else
{
	echo '<li>' . $sql . '<br /> +++ <font color="#0000FF"><b>Table '.$table_prefix.'dl_favorites created</b></font></li><br />';
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';
echo '<li><b>Insert/Convert Configuration Values on Table </b><u>'.$table_prefix.'dl_config</u></li><br />';
echo '<li><b>Alter Groups Table </b><u>'.$table_prefix.'groups</u></li><br />';
echo '<li><b>Alter User Table </b><u>'.$table_prefix.'users</u></li><br />';
echo '<li><b>Prepare file extention blacklist basic values</b></li><br />';

$config_fields = array(
	'dl_click_reset_time',
	'dl_edit_time',
	'dl_links_per_page',
	'dl_new_time',
	'dl_posts',
	'download_dir',
	'enable_post_dl_traffic',
	'newtopic_traffic',
	'recent_downloads',
	'reply_traffic',
	'user_dl_auto_traffic',
	'overall_traffic',
	'remain_traffic',
	'traffic_retime',
	'stop_uploads',
	'upload_traffic_count',
	'physical_quota',
	'delay_auto_traffic',
	'delay_post_traffic',
	'disable_popup',
	'disable_email',
	'guest_stats_show',
	'dl_method',
	'dl_method_quota',
	'dl_stats_perm',
	'dl_mod_version',
	'use_hacklist',
	'thumb_xsize',
	'thumb_ysize',
	'thumb_fsize',
	'show_footer_legend',
	'show_footer_stat',
	'limit_desc_on_index',
	'use_ext_blacklist',
	'disable_popup_notify',
	'show_real_filetime',
	'report_broken',
	'user_traffic_once',
	'prevent_hotlink',
	'hotlink_action',
	'report_broken_lock',
	'report_broken_message',
	'report_broken_vc',
	'download_vc',
	'edit_own_downloads',
	'shorten_extern_links',
	'icon_free_for_reg',
	'latest_comments');

$current_time = time();
$config_values = array(
	'0', '3', '10', '3', '25',
	'downloads/', '1', '524288', '10', '262144',
	'0', '104857600', '0', $current_time, '0',
	'1', '524288000', '30', '30', '0',
	'1', '1', '2', '2097152', '0',
	$current_version, '1', '200', '150', '0',
	'1', '1', '0', '1', '0',
	'1', '1', '0', '1', '1',
	'1', '1', '1', '1', '1',
	'10', '0', '1');

$ext_blacklist = array(
	'asp', 'cgi', 'dhtm', 'dhtml', 'exe', 'htm', 'html',  'jar', 'js', 'php', 'php3', 'pl', 'sh', 'shtm', 'shtml');

$sql = array();

for ($i = 0; $i < count($config_fields); $i++)
{
	$config = ($board_config[$config_fields[$i]] != '') ? $board_config[$config_fields[$i]] : $config_values[$i];
	$sql[] = "INSERT INTO " . $table_prefix . "dl_config (config_name, config_value) VALUES ('".$config_fields[$i]."', '".$config."')";
	$sql[] = "DELETE FROM " . $table_prefix . "config WHERE config_name = '" . $config_fields[$i] . "'";
}	

for ($i = 0; $i < count($ext_blacklist); $i++)
{
	$sql[] = "INSERT INTO " . $table_prefix . "dl_ext_blacklist (extention) VALUES ('".$ext_blacklist[$i]."')";
}	

$sql[] = "DELETE FROM " . $table_prefix . "dl_config WHERE config_name='user_dl_permission'";

$sql[] = "ALTER TABLE " . $table_prefix . "groups ADD COLUMN group_dl_auto_traffic BIGINT(20) DEFAULT '0' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "groups DROP COLUMN group_dl_permission";

$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_allow_new_download_email TINYINT(1) DEFAULT '0' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_allow_fav_download_email TINYINT(1) DEFAULT '1' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_allow_new_download_popup TINYINT(1) DEFAULT '1' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_allow_fav_download_popup TINYINT(1) DEFAULT '1' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_dl_update_time INT( 11 ) DEFAULT '0' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_new_download TINYINT(1) DEFAULT '0' NOT NULL";
$sql[] = "ALTER TABLE " . $table_prefix . "users ADD COLUMN user_traffic BIGINT(20) DEFAULT '0' NOT NULL";

for ($i = 0; $i < count($sql); $i++)
{
	$db->sql_query($sql[$i]);
	$error = $db->sql_error();
	if ($error['message'] != '')
	{
		echo '<li>' . $sql[$i] . '<br /> +++ <font color="#0000FF"><b>Field/Value already up to date</b></font></li><br />';
	}
	else
	{
		echo '<li>' . $sql[$i] . '<br /> +++ <font color="#00AA00"><b>successfull</b></font></li><br />';
	}
}

echo '<li><b>Convert Download Clicks to Overall Clicks</b></li><br />';

unset($sql);
$sql = "SELECT id FROM " . $table_prefix . "downloads
	WHERE overall_klicks = 0";
if (!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not read download clicks for converting', '', __LINE__, __FILE__, $sql);
}

while ($row = $db->sql_fetchrow($result))
{
	$dl_id = $row['id'];
	$sql_dl_update = "UPDATE " . $table_prefix . "downloads
			  SET overall_klicks = klicks
			  WHERE id = $dl_id
			  	AND overall_klicks = 0";
	if (!$result_update = $db->sql_query($sql_dl_update))
	{
		message_die(GENERAL_ERROR, 'Could not write overall download clicks', '', __LINE__, __FILE__, $sql_dl_update);
	}
}

echo '<br /> +++ <font color="#00AA00"><b>successfull</b></font><br /><br />';

echo '<br /><br /><br /><font color="#000000"><h2>Database Update now complete!<h2></font><br /><br />';

echo '</ul></span></td></tr><tr><td class="catBottom" height="28">&nbsp;</td></tr>';

echo '<tr><th>End</th></tr><tr><td><span class="genmed">Installation is now finished. Please be sure to delete this file now.<br />If you have run into any errors, please visit the <a href="http://www.phpbbsupport.co.uk" target="_phpbbsupport">phpBBSupport.co.uk</a> and ask someone for help.</span></td></tr>';
echo '<tr><td class="catBottom" height="28" align="center"><span class="genmed"><a href="' . append_sid("index.$phpEx") . '">Have a nice day</a></span></td></table>';

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>